diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.cc ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.cc
--- ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
@@ -95,9 +95,7 @@
 uint16_t
 IdealWifiManager::GetChannelWidthForNonHtMode(WifiMode mode) const
 {
-    NS_ASSERT(mode.GetModulationClass() != WIFI_MOD_CLASS_HT &&
-              mode.GetModulationClass() != WIFI_MOD_CLASS_VHT &&
-              mode.GetModulationClass() != WIFI_MOD_CLASS_HE);
+    NS_ASSERT(mode.GetModulationClass() < WIFI_MOD_CLASS_HT);
     if (mode.GetModulationClass() == WIFI_MOD_CLASS_DSSS ||
         mode.GetModulationClass() == WIFI_MOD_CLASS_HR_DSSS)
     {
@@ -151,7 +149,7 @@
                     txVector.SetMode(mode);
                     AddSnrThreshold(txVector, GetPhy()->CalculateSnr(txVector, m_ber));
                 }
-                else // VHT or HE
+                else
                 {
                     uint16_t guardInterval;
                     if (mode.GetModulationClass() == WIFI_MOD_CLASS_VHT)
@@ -342,7 +340,6 @@
     // to ensure correct packet delivery.
     WifiMode maxMode = GetDefaultModeForSta(st);
     WifiTxVector txVector;
-    WifiMode mode;
     uint64_t bestRate = 0;
     uint8_t selectedNss = 1;
     uint16_t guardInterval;
@@ -367,24 +364,26 @@
         {
             for (uint8_t i = 0; i < GetNMcsSupported(station); i++)
             {
-                mode = GetMcsSupported(station, i);
+                auto mode = GetMcsSupported(station, i);
+                if (!IsCandidateModulationClass(mode.GetModulationClass(), station))
+                {
+                    continue;
+                }
                 txVector.SetMode(mode);
-                if (mode.GetModulationClass() == WIFI_MOD_CLASS_HT)
+                uint16_t guardInterval;
+                if (mode.GetModulationClass() >= WIFI_MOD_CLASS_HE)
+                {
+                    guardInterval = std::max(GetGuardInterval(station), GetGuardInterval());
+                }
+                else
                 {
                     guardInterval = static_cast<uint16_t>(
                         std::max(GetShortGuardIntervalSupported(station) ? 400 : 800,
                                  GetShortGuardIntervalSupported() ? 400 : 800));
-                    txVector.SetGuardInterval(guardInterval);
-                    // If the node and peer are both VHT capable, only search VHT modes
-                    if (GetVhtSupported() && GetVhtSupported(station))
-                    {
-                        continue;
-                    }
-                    // If the node and peer are both HE capable, only search HE modes
-                    if (GetHeSupported() && GetHeSupported(station))
-                    {
-                        continue;
-                    }
+                }
+                txVector.SetGuardInterval(guardInterval);
+                if (mode.GetModulationClass() == WIFI_MOD_CLASS_HT)
+                {
                     // Derive NSS from the MCS index. There is a different mode for each possible
                     // NSS value.
                     uint8_t nss = (mode.GetMcsValue() / 8) + 1;
@@ -417,64 +416,8 @@
                         selectedNss = nss;
                     }
                 }
-                else if (mode.GetModulationClass() == WIFI_MOD_CLASS_VHT)
-                {
-                    guardInterval = static_cast<uint16_t>(
-                        std::max(GetShortGuardIntervalSupported(station) ? 400 : 800,
-                                 GetShortGuardIntervalSupported() ? 400 : 800));
-                    txVector.SetGuardInterval(guardInterval);
-                    // If the node and peer are both HE capable, only search HE modes
-                    if (GetHeSupported() && GetHeSupported(station))
-                    {
-                        continue;
-                    }
-                    // If the node and peer are not both VHT capable, only search HT modes
-                    if (!GetVhtSupported() || !GetVhtSupported(station))
-                    {
-                        continue;
-                    }
-                    for (uint8_t nss = 1; nss <= std::min(GetMaxNumberOfTransmitStreams(),
-                                                          GetNumberOfSupportedStreams(station));
-                         nss++)
-                    {
-                        txVector.SetNss(nss);
-                        if (!txVector.IsValid())
-                        {
-                            NS_LOG_DEBUG("Skipping mode " << mode.GetUniqueName() << " nss " << +nss
-                                                          << " width "
-                                                          << txVector.GetChannelWidth());
-                            continue;
-                        }
-                        double threshold = GetSnrThreshold(txVector);
-                        uint64_t dataRate = mode.GetDataRate(txVector.GetChannelWidth(),
-                                                             txVector.GetGuardInterval(),
-                                                             nss);
-                        NS_LOG_DEBUG("Testing mode = " << mode.GetUniqueName() << " data rate "
-                                                       << dataRate << " threshold " << threshold
-                                                       << " last snr observed "
-                                                       << station->m_lastSnrObserved << " cached "
-                                                       << station->m_lastSnrCached);
-                        double snr = GetLastObservedSnr(station, channelWidth, nss);
-                        if (dataRate > bestRate && threshold < snr)
-                        {
-                            NS_LOG_DEBUG("Candidate mode = "
-                                         << mode.GetUniqueName() << " data rate " << dataRate
-                                         << " channel width " << channelWidth << " snr " << snr);
-                            bestRate = dataRate;
-                            maxMode = mode;
-                            selectedNss = nss;
-                        }
-                    }
-                }
-                else // HE
+                else
                 {
-                    guardInterval = std::max(GetGuardInterval(station), GetGuardInterval());
-                    txVector.SetGuardInterval(guardInterval);
-                    // If the node and peer are not both HE capable, only search (V)HT modes
-                    if (!GetHeSupported() || !GetHeSupported(station))
-                    {
-                        continue;
-                    }
                     for (uint8_t nss = 1; nss <= std::min(GetMaxNumberOfTransmitStreams(),
                                                           GetNumberOfSupportedStreams(station));
                          nss++)
@@ -517,7 +460,7 @@
             selectedNss = 1;
             for (uint8_t i = 0; i < GetNSupported(station); i++)
             {
-                mode = GetSupported(station, i);
+                auto mode = GetSupported(station, i);
                 txVector.SetMode(mode);
                 txVector.SetNss(selectedNss);
                 uint16_t channelWidth = GetChannelWidthForNonHtMode(mode);
@@ -548,12 +491,11 @@
     NS_LOG_DEBUG("Found maxMode: " << maxMode << " channelWidth: " << channelWidth
                                    << " nss: " << +selectedNss);
     station->m_lastChannelWidth = channelWidth;
-    if (maxMode.GetModulationClass() == WIFI_MOD_CLASS_HE)
+    if ((maxMode.GetModulationClass() >= WIFI_MOD_CLASS_HE))
     {
         guardInterval = std::max(GetGuardInterval(station), GetGuardInterval());
     }
-    else if ((maxMode.GetModulationClass() == WIFI_MOD_CLASS_HT) ||
-             (maxMode.GetModulationClass() == WIFI_MOD_CLASS_VHT))
+    else if ((maxMode.GetModulationClass() >= WIFI_MOD_CLASS_HT))
     {
         guardInterval =
             static_cast<uint16_t>(std::max(GetShortGuardIntervalSupported(station) ? 400 : 800,
@@ -643,4 +585,62 @@
     return snr;
 }
 
+bool
+IdealWifiManager::IsModulationClassSupported(WifiModulationClass mc,
+                                             IdealWifiRemoteStation* station)
+{
+    switch (mc)
+    {
+    case WIFI_MOD_CLASS_HT:
+        return (GetHtSupported() && GetHtSupported(station));
+    case WIFI_MOD_CLASS_VHT:
+        return (GetVhtSupported() && GetVhtSupported(station));
+    case WIFI_MOD_CLASS_HE:
+        return (GetHeSupported() && GetHeSupported(station));
+    case WIFI_MOD_CLASS_EHT:
+        return (GetEhtSupported() && GetEhtSupported(station));
+    default:
+        NS_ABORT_MSG("Unknown modulation class: " << mc);
+    }
+}
+
+bool
+IdealWifiManager::IsCandidateModulationClass(WifiModulationClass mc,
+                                             IdealWifiRemoteStation* station)
+{
+    if (!IsModulationClassSupported(mc, station))
+    {
+        return false;
+    }
+    switch (mc)
+    {
+    case WIFI_MOD_CLASS_HT:
+        // If the node and peer are both VHT capable, skip non-VHT modes
+        if (GetVhtSupported() && GetVhtSupported(station))
+        {
+            return false;
+        }
+        [[fallthrough]];
+    case WIFI_MOD_CLASS_VHT:
+        // If the node and peer are both HE capable, skip non-HE modes
+        if (GetHeSupported() && GetHeSupported(station))
+        {
+            return false;
+        }
+        [[fallthrough]];
+    case WIFI_MOD_CLASS_HE:
+        // If the node and peer are both EHT capable, skip non-EHT modes
+        if (GetEhtSupported() && GetEhtSupported(station))
+        {
+            return false;
+        }
+        break;
+    case WIFI_MOD_CLASS_EHT:
+        break;
+    default:
+        NS_ABORT_MSG("Unknown modulation class: " << mc);
+    }
+    return true;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.h ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.h
--- ns-3.40/src/wifi/model/rate-control/ideal-wifi-manager.h	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/rate-control/ideal-wifi-manager.h	2024-02-09 14:44:08.593795000 -0800
@@ -139,6 +139,23 @@
                               uint8_t nss) const;
 
     /**
+     * Check whether a given modulation class is supported by both the node and the peer
+     * \param mc the modulation class
+     * \param station the peer station
+     * \return true if the modulation class can be used, false otherwise
+     */
+    bool IsModulationClassSupported(WifiModulationClass mc, IdealWifiRemoteStation* station);
+
+    /**
+     * Check whether a given modulation class is supported and that there are no higher modulation
+     * classes that should instead be candidates
+     * \param mc the modulation class
+     * \param station the peer station
+     * \return true if the modulation class is a candidate, false otherwise
+     */
+    bool IsCandidateModulationClass(WifiModulationClass mc, IdealWifiRemoteStation* station);
+
+    /**
      * A vector of <snr, WifiTxVector> pair holding the minimum SNR for the
      * WifiTxVector
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.41/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.40/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2023-09-27 13:30:37.910839800 -0700
+++ ns-3.41/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2024-02-09 14:44:08.593795000 -0800
@@ -644,7 +644,7 @@
 
             // calculating throughput
             station->m_minstrelTable[i].throughput =
-                tempProb * static_cast<uint32_t>((1000000 / txTime.GetMicroSeconds()));
+                tempProb * static_cast<uint32_t>(1000000 / txTime.GetMicroSeconds());
         }
         else
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/sta-wifi-mac.cc ns-3.41/src/wifi/model/sta-wifi-mac.cc
--- ns-3.40/src/wifi/model/sta-wifi-mac.cc	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/sta-wifi-mac.cc	2024-02-09 14:44:08.597795000 -0800
@@ -23,6 +23,7 @@
 
 #include "channel-access-manager.h"
 #include "frame-exchange-manager.h"
+#include "mgt-action-headers.h"
 #include "mgt-headers.h"
 #include "qos-txop.h"
 #include "snr-tag.h"
@@ -135,7 +136,9 @@
                             "A link setup in the context of ML setup with an AP MLD was torn down. "
                             "Provides ID of the setup link and AP MAC address",
                             MakeTraceSourceAccessor(&StaWifiMac::m_setupCanceled),
-                            "ns3::StaWifiMac::LinkSetupCallback")
+                            "ns3::StaWifiMac::LinkSetupCallback",
+                            TypeId::OBSOLETE,
+                            "Disassociation only occurs at MLD level; use DeAssoc trace.")
             .AddTraceSource("BeaconArrival",
                             "Time of beacons arrival from associated AP",
                             MakeTraceSourceAccessor(&StaWifiMac::m_beaconArrival),
@@ -463,6 +466,9 @@
         // When the Transition Timeout subfield is included in a frame sent by a non-AP STA
         // affiliated with a non-AP MLD, the Transition Timeout subfield is reserved
         // (Section 9.4.2.312.2.3 of 802.11be D2.3)
+        // The Medium Synchronization Delay Information subfield in the Common Info subfield is
+        // not present if the Basic Multi-Link element is sent by a non-AP STA. (Section
+        // 9.4.2.312.2.3 of 802.11be D3.1)
     }
 
     // The MLD Capabilities And Operations subfield is present in the Common Info field of the
@@ -475,7 +481,7 @@
 
     auto ehtConfiguration = GetEhtConfiguration();
     NS_ASSERT(ehtConfiguration);
-    EnumValue negSupport;
+    EnumValue<WifiTidToLinkMappingNegSupport> negSupport;
     ehtConfiguration->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
 
     mldCapabilities->tidToLinkMappingSupport = negSupport.Get();
@@ -523,7 +529,7 @@
     auto ehtConfig = GetEhtConfiguration();
     NS_ASSERT(ehtConfig);
 
-    EnumValue negSupport;
+    EnumValue<WifiTidToLinkMappingNegSupport> negSupport;
     ehtConfig->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
 
     NS_ABORT_MSG_IF(negSupport.Get() == 0,
@@ -809,14 +815,9 @@
     };
     Time beaconInterval = std::visit(getBeaconInterval, bestAp->m_frame);
     Time delay = beaconInterval * m_maxMissedBeacons;
-    // restart beacon watchdog for all links to setup
-    for (const auto& [id, link] : GetLinks())
-    {
-        if (GetStaLink(link).bssid.has_value() || GetNLinks() == 1)
-        {
-            RestartBeaconWatchdog(delay, id);
-        }
-    }
+    // restart beacon watchdog
+    RestartBeaconWatchdog(delay);
+
     SetState(WAIT_ASSOC_RESP);
     SendAssociationRequest(false);
 }
@@ -830,92 +831,73 @@
 }
 
 void
-StaWifiMac::MissedBeacons(uint8_t linkId)
+StaWifiMac::MissedBeacons()
 {
-    NS_LOG_FUNCTION(this << +linkId);
-    auto& link = GetLink(linkId);
-    if (link.beaconWatchdogEnd > Simulator::Now())
+    NS_LOG_FUNCTION(this);
+
+    if (m_beaconWatchdogEnd > Simulator::Now())
     {
-        if (link.beaconWatchdog.IsRunning())
+        if (m_beaconWatchdog.IsRunning())
         {
-            link.beaconWatchdog.Cancel();
+            m_beaconWatchdog.Cancel();
         }
-        link.beaconWatchdog = Simulator::Schedule(link.beaconWatchdogEnd - Simulator::Now(),
-                                                  &StaWifiMac::MissedBeacons,
-                                                  this,
-                                                  linkId);
+        m_beaconWatchdog = Simulator::Schedule(m_beaconWatchdogEnd - Simulator::Now(),
+                                               &StaWifiMac::MissedBeacons,
+                                               this);
         return;
     }
     NS_LOG_DEBUG("beacon missed");
-    // We need to switch to the UNASSOCIATED state. However, if we are receiving
-    // a frame, wait until the RX is completed (otherwise, crashes may occur if
-    // we are receiving a MU frame because its reception requires the STA-ID)
+    // We need to switch to the UNASSOCIATED state. However, if we are receiving a frame, wait
+    // until the RX is completed (otherwise, crashes may occur if we are receiving a MU frame
+    // because its reception requires the STA-ID). We need to check that a PHY is operating on
+    // the given link, because this may (temporarily) not be the case for EMLSR clients.
     Time delay = Seconds(0);
-    if (GetWifiPhy(linkId)->IsStateRx())
+    for (const auto& [id, link] : GetLinks())
     {
-        delay = GetWifiPhy(linkId)->GetDelayUntilIdle();
+        if (link->phy && link->phy->IsStateRx())
+        {
+            delay = std::max(delay, link->phy->GetDelayUntilIdle());
+        }
     }
-    Simulator::Schedule(delay, &StaWifiMac::Disassociated, this, linkId);
+    Simulator::Schedule(delay, &StaWifiMac::Disassociated, this);
 }
 
 void
-StaWifiMac::Disassociated(uint8_t linkId)
+StaWifiMac::Disassociated()
 {
-    NS_LOG_FUNCTION(this << +linkId);
-
-    auto& link = GetLink(linkId);
-    if (link.bssid.has_value())
-    {
-        // this is a link setup in an ML setup
-        m_setupCanceled(linkId, GetBssid(linkId));
-    }
+    NS_LOG_FUNCTION(this);
 
-    // disable the given link
-    link.bssid = std::nullopt;
-    link.phy->SetOffMode();
+    Mac48Address apAddr; // the AP address to trace (MLD address in case of ML setup)
 
-    for (const auto& [id, lnk] : GetLinks())
+    for (const auto& [id, link] : GetLinks())
     {
-        if (GetStaLink(lnk).bssid.has_value())
+        auto& bssid = GetStaLink(link).bssid;
+        if (bssid)
         {
-            // found an enabled link
-            return;
+            apAddr = GetWifiRemoteStationManager(id)->GetMldAddress(*bssid).value_or(*bssid);
         }
+        bssid = std::nullopt; // link is no longer setup
     }
 
     NS_LOG_DEBUG("Set state to UNASSOCIATED and start scanning");
     SetState(UNASSOCIATED);
     // cancel the association request timer (see issue #862)
     m_assocRequestEvent.Cancel();
-    auto mldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(GetBssid(linkId));
-    if (GetNLinks() > 1 && mldAddress.has_value())
-    {
-        // trace the AP MLD address
-        m_deAssocLogger(*mldAddress);
-    }
-    else
-    {
-        m_deAssocLogger(GetBssid(linkId));
-    }
+    m_deAssocLogger(apAddr);
     m_aid = 0; // reset AID
-    // ensure all links are on
-    for (const auto& [id, lnk] : GetLinks())
-    {
-        lnk->phy->ResumeFromOff();
-    }
     TryToEnsureAssociated();
 }
 
 void
-StaWifiMac::RestartBeaconWatchdog(Time delay, uint8_t linkId)
+StaWifiMac::RestartBeaconWatchdog(Time delay)
 {
-    NS_LOG_FUNCTION(this << delay << +linkId);
-    auto& link = GetLink(linkId);
-    link.beaconWatchdogEnd = std::max(Simulator::Now() + delay, link.beaconWatchdogEnd);
-    if (Simulator::GetDelayLeft(link.beaconWatchdog) < delay && link.beaconWatchdog.IsExpired())
+    NS_LOG_FUNCTION(this << delay);
+
+    m_beaconWatchdogEnd = std::max(Simulator::Now() + delay, m_beaconWatchdogEnd);
+    if (Simulator::GetDelayLeft(m_beaconWatchdog) < delay && m_beaconWatchdog.IsExpired())
     {
         NS_LOG_DEBUG("really restart watchdog.");
-        link.beaconWatchdog = Simulator::Schedule(delay, &StaWifiMac::MissedBeacons, this, linkId);
+        m_beaconWatchdog = Simulator::Schedule(delay, &StaWifiMac::MissedBeacons, this);
     }
 }
 
@@ -962,7 +944,7 @@
 bool
 StaWifiMac::CanForwardPacketsTo(Mac48Address to) const
 {
-    return (IsAssociated());
+    return IsAssociated();
 }
 
 void
@@ -1060,7 +1042,7 @@
 
     BlockUnicastTxOnLinks(reason, apAddress, {linkId});
     // the only type of broadcast frames that a non-AP STA can send are management frames
-    for (const auto [acIndex, ac] : wifiAcList)
+    for (const auto& [acIndex, ac] : wifiAcList)
     {
         GetMacQueueScheduler()->BlockQueues(reason,
                                             acIndex,
@@ -1082,7 +1064,7 @@
 
     UnblockUnicastTxOnLinks(reason, apAddress, {linkId});
     // the only type of broadcast frames that a non-AP STA can send are management frames
-    for (const auto [acIndex, ac] : wifiAcList)
+    for (const auto& [acIndex, ac] : wifiAcList)
     {
         GetMacQueueScheduler()->UnblockQueues(reason,
                                               acIndex,
@@ -1263,7 +1245,7 @@
         m_beaconArrival(Simulator::Now());
         Time delay = MicroSeconds(std::get<MgtBeaconHeader>(apInfo.m_frame).GetBeaconIntervalUs() *
                                   m_maxMissedBeacons);
-        RestartBeaconWatchdog(delay, linkId);
+        RestartBeaconWatchdog(delay);
         UpdateApInfo(apInfo.m_frame, hdr.GetAddr2(), hdr.GetAddr3(), linkId);
     }
     else
@@ -1461,6 +1443,31 @@
         }
     }
 
+    // the station that associated with the AP may have dissociated and then associated again.
+    // In this case, the station may store packets from the previous period in which it was
+    // associated. Have the station restart access if it has packets queued.
+    for (const auto& [id, link] : GetLinks())
+    {
+        if (GetStaLink(link).bssid)
+        {
+            if (const auto txop = GetTxop())
+            {
+                txop->StartAccessAfterEvent(id,
+                                            Txop::DIDNT_HAVE_FRAMES_TO_TRANSMIT,
+                                            Txop::CHECK_MEDIUM_BUSY);
+            }
+            for (const auto [acIndex, ac] : wifiAcList)
+            {
+                if (const auto edca = GetQosTxop(acIndex))
+                {
+                    edca->StartAccessAfterEvent(id,
+                                                Txop::DIDNT_HAVE_FRAMES_TO_TRANSMIT,
+                                                Txop::CHECK_MEDIUM_BUSY);
+                }
+            }
+        }
+    }
+
     SetPmModeAfterAssociation(linkId);
 }
 
@@ -1473,7 +1480,7 @@
     // acknowledgement of the Association Response. For this purpose, we connect a callback to
     // the PHY TX begin trace to catch the Ack transmitted after the Association Response.
     CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, double>(
-        [=](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
+        [=, this](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
             NS_ASSERT_MSG(psduMap.size() == 1 && psduMap.begin()->second->GetNMpdus() == 1 &&
                               psduMap.begin()->second->GetHeader(0).IsAck(),
                           "Expected a Normal Ack after Association Response frame");
@@ -1782,10 +1789,18 @@
         // is supported by the peer
         GetWifiRemoteStationManager(linkId)->AddStationEhtCapabilities(apAddr, *ehtCapabilities);
 
-        if (const auto& mle = frame.template Get<MultiLinkElement>();
-            mle && mle->HasEmlCapabilities() && m_emlsrManager)
+        if (const auto& mle = frame.template Get<MultiLinkElement>(); mle && m_emlsrManager)
         {
-            m_emlsrManager->SetTransitionTimeout(mle->GetTransitionTimeout());
+            if (mle->HasEmlCapabilities())
+            {
+                m_emlsrManager->SetTransitionTimeout(mle->GetTransitionTimeout());
+            }
+            if (const auto& common = mle->GetCommonInfoBasic(); common.m_mediumSyncDelayInfo)
+            {
+                m_emlsrManager->SetMediumSyncDuration(common.GetMediumSyncDelayTimer());
+                m_emlsrManager->SetMediumSyncOfdmEdThreshold(common.GetMediumSyncOfdmEdThreshold());
+                m_emlsrManager->SetMediumSyncMaxNTxops(common.GetMediumSyncMaxNTxops());
+            }
         }
     };
 
@@ -2013,34 +2028,52 @@
  */
 
 void
-StaWifiMac::NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId)
+StaWifiMac::NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId, Time delay)
 {
-    NS_LOG_FUNCTION(this << phy << linkId);
+    NS_LOG_FUNCTION(this << phy << linkId << delay.As(Time::US));
 
-    // if any link points to the PHY that switched channel, reset the phy pointer
+    // If the PHY is switching channel to operate on another link, then it is no longer operating
+    // on the current link. If any link (other than the current link) points to the PHY that is
+    // switching channel, reset the phy pointer of the link
     for (auto& [id, link] : GetLinks())
     {
-        // auto& link = GetStaLink(lnk);
-        if (link->phy == phy)
+        if (link->phy == phy && id != linkId)
         {
             link->phy = nullptr;
         }
     }
 
-    auto& newLink = GetLink(linkId);
-    // The MAC stack associated with the new link uses the given PHY
-    newLink.phy = phy;
-    // Setup a PHY listener for the given PHY on the CAM associated with the new link
-    newLink.channelAccessManager->SetupPhyListener(phy);
-    NS_ASSERT(m_emlsrManager);
-    if (m_emlsrManager->GetCamStateReset())
-    {
-        newLink.channelAccessManager->ResetState();
-    }
-    // Disconnect the FEM on the new link from the current PHY
-    newLink.feManager->ResetPhy();
-    // Connect the FEM on the new link to the given PHY
-    newLink.feManager->SetWifiPhy(phy);
+    // lambda to connect the PHY to the new link
+    auto connectPhy = [=, this]() mutable {
+        auto& newLink = GetLink(linkId);
+        // The MAC stack associated with the new link uses the given PHY
+        newLink.phy = phy;
+        // Setup a PHY listener for the given PHY on the CAM associated with the new link
+        newLink.channelAccessManager->SetupPhyListener(phy);
+        NS_ASSERT(m_emlsrManager);
+        if (m_emlsrManager->GetCamStateReset())
+        {
+            newLink.channelAccessManager->ResetState();
+        }
+        // Disconnect the FEM on the new link from the current PHY
+        newLink.feManager->ResetPhy();
+        // Connect the FEM on the new link to the given PHY
+        newLink.feManager->SetWifiPhy(phy);
+        // Connect the station manager on the new link to the given PHY
+        newLink.stationManager->SetupPhy(phy);
+    };
+
+    // if there is no PHY operating on the new link, connect the PHY to the new link now.
+    // Otherwise, wait until the channel switch is completed, so that the PHY operating on the new
+    // link can possibly continue receiving frames in the meantime.
+    if (!GetLink(linkId).phy)
+    {
+        connectPhy();
+    }
+    else
+    {
+        Simulator::Schedule(delay, connectPhy);
+    }
 }
 
 void
@@ -2052,7 +2085,7 @@
 
     if (IsInitialized() && IsAssociated())
     {
-        Disassociated(linkId);
+        Disassociated();
     }
 
     // notify association manager
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/sta-wifi-mac.h ns-3.41/src/wifi/model/sta-wifi-mac.h
--- ns-3.40/src/wifi/model/sta-wifi-mac.h	2023-09-27 13:30:37.914839700 -0700
+++ ns-3.41/src/wifi/model/sta-wifi-mac.h	2024-02-09 14:44:08.597795000 -0800
@@ -28,9 +28,7 @@
 #include <set>
 #include <variant>
 
-class TwoLevelAggregationTest;
 class AmpduAggregationTest;
-class HeAggregationTest;
 class MultiLinkOperationsTestBase;
 
 namespace ns3
@@ -144,12 +142,8 @@
 {
   public:
     /// Allow test cases to access private members
-    friend class ::TwoLevelAggregationTest;
-    /// Allow test cases to access private members
     friend class ::AmpduAggregationTest;
     /// Allow test cases to access private members
-    friend class ::HeAggregationTest;
-    /// Allow test cases to access private members
     friend class ::MultiLinkOperationsTestBase;
 
     /// type of the management frames used to get info about APs
@@ -313,8 +307,9 @@
      *
      * \param phy the given PHY
      * \param linkId the ID of the EMLSR link on which the given PHY is operating
+     * \param delay the delay after which the channel switch will be completed
      */
-    void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId);
+    void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId, Time delay);
 
     /**
      * Block transmissions on the given link for the given reason.
@@ -357,8 +352,6 @@
         bool sendAssocReq;                 //!< whether this link is used to send the
                                            //!< Association Request frame
         std::optional<Mac48Address> bssid; //!< BSSID of the AP to associate with over this link
-        EventId beaconWatchdog;            //!< beacon watchdog
-        Time beaconWatchdogEnd{0};         //!< beacon watchdog end
         WifiPowerManagementMode pmMode{WIFI_PM_ACTIVE}; /**< the current PM mode, if the STA is
                                                              associated, or the PM mode to switch
                                                              to upon association, otherwise */
@@ -506,27 +499,19 @@
      */
     bool IsWaitAssocResp() const;
     /**
-     * This method is called after we have not received a beacon from the AP
-     * on the given link.
-     *
-     * \param linkId the ID of the given link
+     * This method is called after we have not received a beacon from the AP on any link.
      */
-    void MissedBeacons(uint8_t linkId);
+    void MissedBeacons();
     /**
-     * Restarts the beacon timer for the given link.
+     * Restarts the beacon timer.
      *
      * \param delay the delay before the watchdog fires
-     * \param linkId the ID of the given link
      */
-    void RestartBeaconWatchdog(Time delay, uint8_t linkId);
+    void RestartBeaconWatchdog(Time delay);
     /**
-     * Check if any enabled link remains after the given link is disabled (because,
-     * e.g., the maximum number of beacons is missed or the channel is switched).
-     * If no enabled link remains, proceed with disassociation.
-     *
-     * \param linkId the ID of the given link
+     * Set the state to unassociated and try to associate again.
      */
-    void Disassociated(uint8_t linkId);
+    void Disassociated();
     /**
      * Return an instance of SupportedRates that contains all rates that we support
      * including HT rates.
@@ -632,6 +617,8 @@
     Time m_assocRequestTimeout;             ///< association request timeout
     EventId m_assocRequestEvent;            ///< association request event
     uint32_t m_maxMissedBeacons;            ///< maximum missed beacons
+    EventId m_beaconWatchdog;               //!< beacon watchdog
+    Time m_beaconWatchdogEnd{0};            //!< beacon watchdog end
     bool m_activeProbing;                   ///< active probing
     Ptr<RandomVariableStream> m_probeDelay; ///< RandomVariable used to randomize the time
                                             ///< of the first Probe Response on each channel
